<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm"
        crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
        crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
        crossorigin="anonymous"></script>
    <title>Chat</title>
    <style>
        #messages {
        height: 300px;
    }
    </style>
</head>

<body>
    <div class="container">
        <div class="row">
            <div class="col-md-6 offset-md-3 col-sm-12">
                <h1 class="text-center">
                    Mongo Chat
                    <button id="clear" class="btn btn-danger">
                        Clear
                    </button>
                </h1>
                <div id="status">Void</div>
                <div id="chat">
                    <input type="text" id="username" class="form-control" placeholder="Enter name...">
                    <br>
                    <div class="card">
                        <div id="messages" class="card-block">

                        </div>
                    </div>
                    <br>
                    <textarea name="" id="textarea" class="form-control" placeholder="Enter your message" cols="30"
                        rows="10"></textarea>
                </div>
            </div>
        </div>
    </div>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.2.0/socket.io.js"></script>
    <script>
        (function () {
            var element = function (id) {
                return document.getElementById(id);
            }

            // get
            var statusCurrent = element('status');
            var messages = element('messages');
            var textarea = element('textarea');
            var username = element('username');
            var clearBtn = element('clear');

            // setDefStatus
            var statusDefault = status.textContent;

            var setStatus = function (status) {
                statusCurrent.textContent = status;
                if (status != statusDefault) {
                    var delay = setTimeout(function () {
                        setStatus(statusDefault);
                    }, 4000)
                }
            }

            // connect
            var socket = io.connect('http://127.0.0.1:4000');
            if (socket !== undefined) {
                console.log("Connected to localhost...");
                //handle output
                socket.on('output', function (data) {
                    console.log(data);
                    if (data.length) {
                        for (var x = 0; x < data.length; x++) {
                            var message = document.createElement('div');
                            message.setAttribute('class', 'chat-message');
                            message.textContent = data[x].name + ": " + data[x].message;
                            messages.appendChild(message);
                            messages.insertBefore(message, messages.firstChild);
                        }
                    }
                });

                //get status
                socket.on('status', function (data) {
                    //get message status
                    var status = typeof data === 'object' ? data.message : data
                    setStatus(status);

                    //if status is clear
                    if (data.clear) {
                        textarea.value = '';
                    }
                });

                //handle input
                textarea.addEventListener('keydown', function (event) {
                    console.log(event.which)
                    if (event.which === 13 && event.shiftKey == false) {
                        //emit  to the server input
                        var data = {
                            name: username.value,
                            message: textarea.value
                        }
                        console.log("emit ", )
                        socket.emit('input', data);

                        event.preventDefault();
                    }
                });

                clearBtn.addEventListener('click',function(){
                    socket.emit('clear');
                });

                socket.on('cleared', function(){
                    messages.textContent = '';
                });

            }

        })();
    </script>
</body>

</html>